import random



class Carta:

    ListaSemi = ["Fiori", "Quadri", "Cuori", "Picche"]
    ListaRanghi = ["impossibile", "Asso", "2", "3", "4", "5", "6", "7", "8", "9", "10", "Jack", "Regina", "Re"]

    def __init__(self, Seme=0, Rango=0):
        self.Seme = Seme
        self.Rango = Rango
        
    def __str__(self):
        return (self.ListaRanghi[self.Rango] + " di " + self.ListaSemi[self.Seme])

    def __cmp__(self, Altro):
        # controlla il seme
        if self.Seme > Altro.Seme: return 1
        if self.Seme < Altro.Seme: return -1
        # se i semi sono uguali controlla il rango
        if self.Rango > Altro.Rango: return 1
        if self.Rango < Altro.Rango: return -1
        # se anche i ranghi sono uguali le carte sono uguali!
        return 0



class Mazzo:
    
    def __init__(self):
        self.Carte = []
        for Seme in range(4):
            for Rango in range(1, 14):
                self.Carte.append(Carta(Seme, Rango))
    
    def StampaMazzo(self):
        for Carta in self.Carte:
            print Carta
    
    def __str__(self):
        s = ""
        for i in range(len(self.Carte)):
            s = s + " "*i + str(self.Carte[i]) + "\n"
        return s

    def Mischia(self):
        import random
        NumCarte = len(self.Carte)
        for i in range(NumCarte):
            j = random.randrange(i, NumCarte)
            self.Carte[i], self.Carte[j] = self.Carte[j], self.Carte[i]

    def RimuoviCarta(self, Carta):
        if Carta in self.Carte:
            self.Carte.remove(Carta)
            return 1
        else:
            return 0
            
    def PrimaCarta(self):
        return self.Carte.pop()
 
    def EVuoto(self):
        return (len(self.Carte) == 0)

    def Distribuisci(self, ListaMani, NumCarte=999):
        NumMani = len(ListaMani)
        for i in range(NumCarte):
            if self.EVuoto(): break       # si ferma se non ci sono
                                          # piu` carte
            Carta = self.PrimaCarta()     # prende la carta
                                          # superiore del mazzo
            Mano = ListaMani[i % NumMani] # di chi e` il prossimo
                                          # turno?
            Mano.AggiungiCarta(Carta)     # aggiungi la carta
                                          # alla mano


class Mano(Mazzo):

    def __init__(self, Nome=""):
        self.Carte = []
        self.Nome = Nome
    
    def AggiungiCarta(self,Carta) :
        self.Carte.append(Carta)
    
    def __str__(self):
        s = "La mano di " + self.Nome
        if self.EVuoto():
            s = s + " e' vuota\n"
        else:
            s = s + " contiene queste carte:\n"
        return s + Mazzo.__str__(self)



class ManoOldMaid(Mano):

    def RimuoviCoppie(self):
        Conteggio = 0
        CarteOriginali = self.Carte[:]
	for CartaOrig in CarteOriginali:
	    CartaDaCercare = Carta(3-CartaOrig.Seme, CartaOrig.Rango)
	    if CartaDaCercare in self.Carte:
	       self.Carte.remove(CartaOrig)
	       self.Carte.remove(CartaDaCercare)
	       print "Mano di %s: %s elimina %s" % (self.Nome,CartaOrig,CartaDaCercare)
	       Conteggio = Conteggio + 1
        return Conteggio



class GiocoCarte:

    def __init__(self):
        self.Mazzo = Mazzo()
        self.Mazzo.Mischia()



class GiocoOldMaid(GiocoCarte):

    def Partita(self, Nomi):
        # rimozione della regina di fiori
        self.Mazzo.RimuoviCarta(Carta(0,12))
        # creazione di una mano per ogni giocatore
        self.Mani = []
        for Nome in Nomi:
            self.Mani.append(ManoOldMaid(Nome))
        # distribuzione delle carte
        self.Mazzo.Distribuisci(self.Mani)
        print "---------- Le carte sono state distribuite"
        self.StampaMani()
        # toglie le coppie iniziali
        NumCoppie = self.RimuoveTutteLeCoppie()
        print "---------- Coppie scartate, inizia la partita"
        self.StampaMani()
        # gioca finche' sono state fatte 50 coppie
        Turno = 0
        NumMani = len(self.Mani)
        while NumCoppie < 25:
            NumCoppie = NumCoppie + self.GiocaUnTurno(Turno)
            Turno = (Turno + 1) % NumMani
        print "---------- La partita e' finita"
        self.StampaMani()
    
    def RimuoveTutteLeCoppie(self):
        Conteggio = 0
        for Mano in self.Mani:
            Conteggio = Conteggio + Mano.RimuoviCoppie()
        return Conteggio

    def GiocaUnTurno(self, Giocatore):
        if self.Mani[Giocatore].EVuoto():
            return 0
        Vicino = self.TrovaVicino(Giocatore)
        CartaScelta = self.Mani[Vicino].PrimaCarta()
        self.Mani[Giocatore].AggiungiCarta(CartaScelta)
        print "Mano di", self.Mani[Giocatore].Nome, ": scelta", CartaScelta
        Conteggio = self.Mani[Giocatore].RimuoviCoppie()
        self.Mani[Giocatore].Mischia()
        return Conteggio

    def TrovaVicino(self, Giocatore):
        NumMani = len(self.Mani)
        for Prossimo in range(1,NumMani):
            Vicino = (Giocatore + Prossimo) % NumMani
            if not self.Mani[Vicino].EVuoto():
                return Vicino
                
    def StampaMani(self):
        print "Funzione da implementare!!! ( StampaMani )"